/[gentoo-x86]/eclass/ghc-package.eclass
Gentoo

Diff of /eclass/ghc-package.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.29 Revision 1.35
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/ghc-package.eclass,v 1.29 2011/03/13 20:12:13 slyfox Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/ghc-package.eclass,v 1.35 2012/11/16 15:47:17 slyfox Exp $
4# 4
5# @ECLASS: ghc-package.eclass 5# @ECLASS: ghc-package.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# "Gentoo's Haskell Language team" <haskell@gentoo.org> 7# "Gentoo's Haskell Language team" <haskell@gentoo.org>
8# 8# @AUTHOR:
9# Original Author: Andres Loeh <kosmikus@gentoo.org> 9# Original Author: Andres Loeh <kosmikus@gentoo.org>
10#
11# @BLURB: This eclass helps with the Glasgow Haskell Compiler's package configuration utility. 10# @BLURB: This eclass helps with the Glasgow Haskell Compiler's package configuration utility.
12# @DESCRIPTION: 11# @DESCRIPTION:
13# Helper eclass to handle ghc installation/upgrade/deinstallation process. 12# Helper eclass to handle ghc installation/upgrade/deinstallation process.
14 13
15inherit versionator 14inherit versionator
35# bypass the script under certain circumstances); 34# bypass the script under certain circumstances);
36# for Cabal, we add an empty global package config file, 35# for Cabal, we add an empty global package config file,
37# because for some reason the global package file 36# because for some reason the global package file
38# must be specified 37# must be specified
39ghc-getghcpkgbin() { 38ghc-getghcpkgbin() {
40 if version_is_at_least "6.10" "$(ghc-version)"; then
41 # the ghc-pkg executable changed name in ghc 6.10, as it no longer needs 39 # the ghc-pkg executable changed name in ghc 6.10, as it no longer needs
42 # the wrapper script with the static flags 40 # the wrapper script with the static flags
43 echo '[]' > "${T}/empty.conf" 41 echo '[]' > "${T}/empty.conf"
42 if version_is_at_least "7.7.20121101" "$(ghc-version)"; then
43 # was moved to bin/ subtree by:
44 # http://www.haskell.org/pipermail/cvs-ghc/2012-September/076546.html
45 echo "$(ghc-libdir)/bin/ghc-pkg" "--global-package-db=${T}/empty.conf"
46 elif version_is_at_least "7.5.20120516" "$(ghc-version)"; then
47 echo "$(ghc-libdir)/ghc-pkg" "--global-package-db=${T}/empty.conf"
48 else
44 echo "$(ghc-libdir)/ghc-pkg" "--global-conf=${T}/empty.conf" 49 echo "$(ghc-libdir)/ghc-pkg" "--global-conf=${T}/empty.conf"
45 elif ghc-cabal; then
46 echo '[]' > "${T}/empty.conf"
47 echo "$(ghc-libdir)/ghc-pkg.bin" "--global-conf=${T}/empty.conf"
48 else
49 echo "$(ghc-libdir)/ghc-pkg.bin"
50 fi 50 fi
51} 51}
52 52
53# @FUNCTION: ghc-version 53# @FUNCTION: ghc-version
54# @DESCRIPTION: 54# @DESCRIPTION:
59 _GHC_VERSION_CACHE="$($(ghc-getghc) --numeric-version)" 59 _GHC_VERSION_CACHE="$($(ghc-getghc) --numeric-version)"
60 fi 60 fi
61 echo "${_GHC_VERSION_CACHE}" 61 echo "${_GHC_VERSION_CACHE}"
62} 62}
63 63
64# @FUNCTION: ghc-cabal
65# @DESCRIPTION:
66# this function can be used to determine if ghc itself
67# uses the Cabal package format; it has nothing to do
68# with the Cabal libraries ... ghc uses the Cabal package
69# format since version 6.4
70ghc-cabal() {
71 version_is_at_least "6.4" "$(ghc-version)"
72}
73
74# @FUNCTION: ghc-bestcabalversion 64# @FUNCTION: ghc-bestcabalversion
75# @DESCRIPTION: 65# @DESCRIPTION:
76# return the best version of the Cabal library that is available 66# return the best version of the Cabal library that is available
77ghc-bestcabalversion() { 67ghc-bestcabalversion() {
78 local cabalversion
79 if ghc-cabal; then
80 # We ask portage, not ghc, so that we only pick up 68 # We ask portage, not ghc, so that we only pick up
81 # portage-installed cabal versions. 69 # portage-installed cabal versions.
82 cabalversion="$(ghc-extractportageversion dev-haskell/cabal)" 70 local cabalversion="$(ghc-extractportageversion dev-haskell/cabal)"
83 echo "Cabal-${cabalversion}" 71 echo "Cabal-${cabalversion}"
84 else
85 # older ghc's don't support package versioning
86 echo Cabal
87 fi
88} 72}
89 73
90# @FUNCTION: ghc-sanecabal 74# @FUNCTION: ghc-sanecabal
91# @DESCRIPTION: 75# @DESCRIPTION:
92# check if a standalone Cabal version is available for the 76# check if a standalone Cabal version is available for the
100 [[ -f "${f}" ]] && version_is_at_least "${version}" "${f#*cabal-}" && return 84 [[ -f "${f}" ]] && version_is_at_least "${version}" "${f#*cabal-}" && return
101 done 85 done
102 return 1 86 return 1
103} 87}
104 88
105# @FUNCTION: ghc-saneghc 89# @FUNCTION: ghc-supports-shared-libraries
106# @DESCRIPTION: 90# @DESCRIPTION:
107# checks if ghc and ghc-bin are installed in the same version 91# checks if ghc is built with support for building
108# (if they're both installed); if this is not the case, we 92# shared libraries (aka '-dynamic' option)
109# unfortunately cannot trust portage's dependency resolution 93ghc-supports-shared-libraries() {
110ghc-saneghc() { 94 $(ghc-getghc) --info | grep "RTS ways" | grep -q "dyn"
111 local ghcversion
112 local ghcbinversion
113 if [[ "${PN}" == "ghc" || "${PN}" == "ghc-bin" ]]; then
114 return
115 fi
116 if has_version dev-lang/ghc && has_version dev-lang/ghc-bin; then
117 ghcversion="$(ghc-extractportageversion dev-lang/ghc)"
118 ghcbinversion="$(ghc-extractportageversion dev-lang/ghc-bin)"
119 if [[ "${ghcversion}" != "${ghcbinversion}" ]]; then
120 return 1
121 fi
122 fi
123 return
124} 95}
125 96
126# @FUNCTION: ghc-extractportageversion 97# @FUNCTION: ghc-extractportageversion
127# @DESCRIPTION: 98# @DESCRIPTION:
128# extract the version of a portage-installed package 99# extract the version of a portage-installed package
169 local outfile 140 local outfile
170 outfile="$(dirname $1)/$(basename $1 | sed 's:^lib\?\(.*\)\.a$:\1.o:')" 141 outfile="$(dirname $1)/$(basename $1 | sed 's:^lib\?\(.*\)\.a$:\1.o:')"
171 ld --relocatable --discard-all --output="${outfile}" --whole-archive "$1" 142 ld --relocatable --discard-all --output="${outfile}" --whole-archive "$1"
172} 143}
173 144
174# @FUNCTION: ghc-makeghcilib 145# @FUNCTION: ghc-package-exists
175# @DESCRIPTION: 146# @DESCRIPTION:
176# tests if a ghc package exists 147# tests if a ghc package exists
177ghc-package-exists() { 148ghc-package-exists() {
178 local describe_flag
179 if version_is_at_least "6.4" "$(ghc-version)"; then
180 describe_flag="describe"
181 else
182 describe_flag="--show-package"
183 fi
184
185 $(ghc-getghcpkg) "${describe_flag}" "$1" > /dev/null 2>&1 149 $(ghc-getghcpkg) describe "$1" > /dev/null 2>&1
186} 150}
187 151
188# @FUNCTION: ghc-setup-pkg 152# @FUNCTION: ghc-setup-pkg
189# @DESCRIPTION: 153# @DESCRIPTION:
190# creates a local (package-specific) package 154# creates a local (package-specific) package
192# uninstalled package description files, each 156# uninstalled package description files, each
193# containing a single package description; if 157# containing a single package description; if
194# no arguments are given, the resulting file is 158# no arguments are given, the resulting file is
195# empty 159# empty
196ghc-setup-pkg() { 160ghc-setup-pkg() {
197 local localpkgconf
198 localpkgconf="${S}/$(ghc-localpkgconf)" 161 local localpkgconf="${S}/$(ghc-localpkgconf)"
199 echo '[]' > "${localpkgconf}" 162 echo '[]' > "${localpkgconf}"
200 local update_flag 163
201 if version_is_at_least "6.4" "$(ghc-version)"; then
202 update_flag="update -"
203 else
204 update_flag="--update-package"
205 fi
206 for pkg in $*; do 164 for pkg in $*; do
207 $(ghc-getghcpkgbin) -f "${localpkgconf}" ${update_flag} --force \ 165 $(ghc-getghcpkgbin) -f "${localpkgconf}" update - --force \
208 < "${pkg}" || die "failed to register ${pkg}" 166 < "${pkg}" || die "failed to register ${pkg}"
209 done 167 done
210} 168}
211 169
212# @FUNCTION: ghc-fixlibpath 170# @FUNCTION: ghc-fixlibpath
233# @FUNCTION: ghc-register-pkg 191# @FUNCTION: ghc-register-pkg
234# @DESCRIPTION: 192# @DESCRIPTION:
235# registers all packages in the local (package-specific) 193# registers all packages in the local (package-specific)
236# package configuration file 194# package configuration file
237ghc-register-pkg() { 195ghc-register-pkg() {
238 local localpkgconf
239 localpkgconf="$(ghc-confdir)/$1" 196 local localpkgconf="$(ghc-confdir)/$1"
240 local update_flag 197
241 local describe_flag
242 if version_is_at_least "6.4" "$(ghc-version)"; then
243 update_flag="update -"
244 describe_flag="describe"
245 else
246 update_flag="--update-package"
247 describe_flag="--show-package"
248 fi
249 if [[ -f "${localpkgconf}" ]]; then 198 if [[ -f "${localpkgconf}" ]]; then
250 for pkg in $(ghc-listpkg "${localpkgconf}"); do 199 for pkg in $(ghc-listpkg "${localpkgconf}"); do
251 ebegin "Registering ${pkg} " 200 ebegin "Registering ${pkg} "
252 $(ghc-getghcpkgbin) -f "${localpkgconf}" "${describe_flag}" "${pkg}" \ 201 $(ghc-getghcpkgbin) -f "${localpkgconf}" describe "${pkg}" \
253 | $(ghc-getghcpkg) ${update_flag} --force > /dev/null 202 | $(ghc-getghcpkg) update - --force > /dev/null
254 eend $? 203 eend $?
255 done 204 done
256 fi 205 fi
257} 206}
258 207
277# @DESCRIPTION: 226# @DESCRIPTION:
278# unregisters a package configuration file 227# unregisters a package configuration file
279# protected are all packages that are still contained in 228# protected are all packages that are still contained in
280# another package configuration file 229# another package configuration file
281ghc-unregister-pkg() { 230ghc-unregister-pkg() {
282 local localpkgconf 231 local localpkgconf="$(ghc-confdir)/$1"
283 local i 232 local i
284 local pkg 233 local pkg
285 local protected
286 local unregister_flag
287 localpkgconf="$(ghc-confdir)/$1"
288
289 if version_is_at_least "6.4" "$(ghc-version)"; then
290 unregister_flag="unregister"
291 else
292 unregister_flag="--remove-package"
293 fi
294
295 for i in $(ghc-confdir)/*.conf; do
296 [[ "${i}" != "${localpkgconf}" ]] && protected="${protected} $(ghc-listpkg ${i})"
297 done
298 # protected now contains the packages that cannot be unregistered yet
299 234
300 if [[ -f "${localpkgconf}" ]]; then 235 if [[ -f "${localpkgconf}" ]]; then
301 for pkg in $(ghc-reverse "$(ghc-listpkg ${localpkgconf})"); do 236 for pkg in $(ghc-reverse "$(ghc-listpkg ${localpkgconf})"); do
302 if $(ghc-elem "${pkg}" "${protected}"); then
303 einfo "Package ${pkg} is protected."
304 elif ! ghc-package-exists "${pkg}"; then 237 if ! ghc-package-exists "${pkg}"; then
305 :
306 # einfo "Package ${pkg} is not installed for ghc-$(ghc-version)." 238 einfo "Package ${pkg} is not installed for ghc-$(ghc-version)."
307 else 239 else
308 ebegin "Unregistering ${pkg} " 240 ebegin "Unregistering ${pkg} "
309 $(ghc-getghcpkg) "${unregister_flag}" "${pkg}" --force > /dev/null 241 $(ghc-getghcpkg) unregister "${pkg}" --force > /dev/null
310 eend $? 242 eend $?
311 fi 243 fi
312 done 244 done
313 fi 245 fi
314} 246}
315 247
316# @FUNCTION: ghc-reverse 248# @FUNCTION: ghc-reverse
345 local extra_flags 277 local extra_flags
346 if version_is_at_least '6.12.3' "$(ghc-version)"; then 278 if version_is_at_least '6.12.3' "$(ghc-version)"; then
347 extra_flags="${extra_flags} -v0" 279 extra_flags="${extra_flags} -v0"
348 fi 280 fi
349 for i in $*; do 281 for i in $*; do
350 if ghc-cabal; then
351 echo $($(ghc-getghcpkg) list ${extra_flags} -f "${i}") \ 282 echo $($(ghc-getghcpkg) list ${extra_flags} -f "${i}") \
352 | sed \ 283 | sed \
353 -e "s|^.*${i}:\([^:]*\).*$|\1|" \ 284 -e "s|^.*${i}:\([^:]*\).*$|\1|" \
354 -e "s|/.*$||" \ 285 -e "s|/.*$||" \
355 -e "s|,| |g" -e "s|[(){}]||g" 286 -e "s|,| |g" -e "s|[(){}]||g"
356 else
357 echo $($(ghc-getghcpkgbin) -l -f "${i}") \
358 | cut -f2 -d':' \
359 | sed 's:,: :g'
360 fi
361 done 287 done
362}
363
364# @FUNCTION: ghc-package_pkg_setup
365# @DESCRIPTION:
366# exported function: check if we have a consistent ghc installation
367ghc-package_pkg_setup() {
368 if ! ghc-saneghc; then
369 eerror "You have inconsistent versions of dev-lang/ghc and dev-lang/ghc-bin"
370 eerror "installed. Portage currently cannot work correctly with this setup."
371 eerror "There are several possibilities to work around this problem:"
372 eerror "(1) Up/downgrade ghc-bin to the same version as ghc."
373 eerror "(2) Unmerge ghc-bin."
374 eerror "(3) Unmerge ghc."
375 eerror "You probably want option 1 or 2."
376 die "Inconsistent versions of ghc and ghc-bin."
377 fi
378} 288}
379 289
380# @FUNCTION: ghc-package_pkg_postinst 290# @FUNCTION: ghc-package_pkg_postinst
381# @DESCRIPTION: 291# @DESCRIPTION:
382# exported function: registers the package-specific package 292# exported function: registers the package-specific package
393# package configuration file ... 303# package configuration file ...
394ghc-package_pkg_prerm() { 304ghc-package_pkg_prerm() {
395 ghc-unregister-pkg "$(ghc-localpkgconf)" 305 ghc-unregister-pkg "$(ghc-localpkgconf)"
396} 306}
397 307
398EXPORT_FUNCTIONS pkg_setup pkg_postinst pkg_prerm 308EXPORT_FUNCTIONS pkg_postinst pkg_prerm

Legend:
Removed from v.1.29  
changed lines
  Added in v.1.35

  ViewVC Help
Powered by ViewVC 1.1.20